/* ------------------------------------------------------------------------
System       : PRODOS 8
Platform     : Apple IIe Enhanced 128K or equivalent
Program      : silly.h
Description  : header file for silly.c version 3.0
Written by   : Bill Buckels
Date Written : January 2015
Licence      : You may use these routines for whatever you wish as long
               as you agree that Bill Buckels has no warranty or
               liability obligations whatsoever from said use.
------------------------------------------------------------------------ */

/* the following soft switches select between
   upper and lower banks of video memory */
#define  dhrmain ((unsigned char*)0xC054)
#define  dhraux  ((unsigned char*)0xC055)

#define ENGLISH 0
#define FRENCH  1

int language=ENGLISH;

/* indices for top, middle, and bottom */
int tidx = 0, midx = 0, bidx = 0;
int todx = 0, modx = 0, bodx = 0;

char sillyname[41], proname[41];

/* flag for mixed-mode */
int bottom = 0;

/* 10 silly things */
char *sillies[10] = {
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL};

/* english names */
char *enames[10] = {
	"DRAGON",
	"ROBOT",
	"CARROT",
	"RHINO",
	"ELEPHANT",
	"CLOWN",
	"FAIRY",
	"MOUSE",
	"FISH",
	"UNICORN"};

/* french names */
char *fnames[10] = {
	"DRAGON",
	"ROBOT",
	"CAROTTE",
	"RHINOCEROS",
	"ELEPHANT",
	"CLOWN",
	"FAIRY",
	"MOUSE",
	"FISH",
	"UNICORN"};

char *putdisk = NULL;
char *eputdisk = "Put Data Disk into drive...";
char *fputdisk = "CHANGEZ A LA DISQUETTE DE DONNEES.";

char *saveprompt = NULL;
char *esaveprompt = "SPACE to SAVE.";
char *fsaveprompt = "LA TOUCHE D'ESPACE POUR COPIER.";

char *savenot = NULL;
char *esavenot = "Any other key to continue...";
char *fsavenot = "UNE TOUCHE D'AUTRE POUR CONTINUER.";

char *wait = NULL;
char *ewait = "Please Wait...";
char *fwait = "UNE MOMENT SVP...";

char *openerr = NULL;
char *eopenerr = "ERR Could not open...";
char *fopenerr = "ERR NE POURRAIT PAS OUVRIR...";

char *writerr = NULL;
char *ewriterr = "ERR Could not write...";
char *fwriterr = "ERR NE POURRAIT PAS ECRIRE...";

char *saveok = NULL;
char *esaveok = "Saved Silly Thing...";
char *fsaveok = "LE FARFELUE A ETE COPIEE AVEC SUCCES.";

char *putprog = NULL;
char *eputprog ="Put Program Disk into drive...";
char *fputprog ="CHANGEZ A LA DISQUETTE DE LOGICIEL.";

char *anykey = NULL;
char *eanykey ="Any key to continue...";
char *fanykey ="APPUYEZ SUR UNE TOUCHE POUR CONTINUER.";

char *menu1 = NULL;
char *menu2 = NULL;

char *emenu1 = "TOP  '1'       MIDDLE '2'    BOTTOM '3'";
char *emenu2 = "MENU=SPACEBAR  FRENCH 'F'      SAVE 'S'";

char *fmenu1 = "LA TETE '1'    LE TORSE '2'  LE BAS '3'";
char *fmenu2 = "LE MENU=ESPACE  ANGLAIS 'A'  COPIER 'C'";

char lodebuf[1024];

/* HGR Base Array */
/* provides base address for 192 page1 hires scanlines  */
unsigned HB[]={
0x2000, 0x2400, 0x2800, 0x2C00, 0x3000, 0x3400, 0x3800, 0x3C00,
0x2080, 0x2480, 0x2880, 0x2C80, 0x3080, 0x3480, 0x3880, 0x3C80,
0x2100, 0x2500, 0x2900, 0x2D00, 0x3100, 0x3500, 0x3900, 0x3D00,
0x2180, 0x2580, 0x2980, 0x2D80, 0x3180, 0x3580, 0x3980, 0x3D80,
0x2200, 0x2600, 0x2A00, 0x2E00, 0x3200, 0x3600, 0x3A00, 0x3E00,
0x2280, 0x2680, 0x2A80, 0x2E80, 0x3280, 0x3680, 0x3A80, 0x3E80,
0x2300, 0x2700, 0x2B00, 0x2F00, 0x3300, 0x3700, 0x3B00, 0x3F00,
0x2380, 0x2780, 0x2B80, 0x2F80, 0x3380, 0x3780, 0x3B80, 0x3F80,
0x2028, 0x2428, 0x2828, 0x2C28, 0x3028, 0x3428, 0x3828, 0x3C28,
0x20A8, 0x24A8, 0x28A8, 0x2CA8, 0x30A8, 0x34A8, 0x38A8, 0x3CA8,
0x2128, 0x2528, 0x2928, 0x2D28, 0x3128, 0x3528, 0x3928, 0x3D28,
0x21A8, 0x25A8, 0x29A8, 0x2DA8, 0x31A8, 0x35A8, 0x39A8, 0x3DA8,
0x2228, 0x2628, 0x2A28, 0x2E28, 0x3228, 0x3628, 0x3A28, 0x3E28,
0x22A8, 0x26A8, 0x2AA8, 0x2EA8, 0x32A8, 0x36A8, 0x3AA8, 0x3EA8,
0x2328, 0x2728, 0x2B28, 0x2F28, 0x3328, 0x3728, 0x3B28, 0x3F28,
0x23A8, 0x27A8, 0x2BA8, 0x2FA8, 0x33A8, 0x37A8, 0x3BA8, 0x3FA8,
0x2050, 0x2450, 0x2850, 0x2C50, 0x3050, 0x3450, 0x3850, 0x3C50,
0x20D0, 0x24D0, 0x28D0, 0x2CD0, 0x30D0, 0x34D0, 0x38D0, 0x3CD0,
0x2150, 0x2550, 0x2950, 0x2D50, 0x3150, 0x3550, 0x3950, 0x3D50,
0x21D0, 0x25D0, 0x29D0, 0x2DD0, 0x31D0, 0x35D0, 0x39D0, 0x3DD0,
0x2250, 0x2650, 0x2A50, 0x2E50, 0x3250, 0x3650, 0x3A50, 0x3E50,
0x22D0, 0x26D0, 0x2AD0, 0x2ED0, 0x32D0, 0x36D0, 0x3AD0, 0x3ED0,
0x2350, 0x2750, 0x2B50, 0x2F50, 0x3350, 0x3750, 0x3B50, 0x3F50,
0x23D0, 0x27D0, 0x2BD0, 0x2FD0, 0x33D0, 0x37D0, 0x3BD0, 0x3FD0};

/* base addresses for last 4 lines of text screen memory page 1 */
unsigned dlotextbase[4]={
    0x0650,
    0x06D0,
    0x0750,
    0x07D0};

/* some functions to output text directly to the screen in mixed mode double lo-res
   and double hi-res graphics */

/* clear the bottom 4 lines of the text screen in mixed mode double res */
void dloclear_bottom(void)
{
	char *crt;
	int row, col;
	char c = 32 + 128;

	for (row = 0; row < 4; row++) {
	  crt = (char *)(dlotextbase[row]);
      for (col = 0; col < 40; col++) {
		  dhraux[0] = 0; /* select auxiliary memory */
		  crt[col] = c;
		  dhrmain[0] = 0; /* reset to main memory */
		  crt[col] = c;
	  }
    }
}

/* print string directly to text screen memory in mixed mode double res */
/* row settings = 0,0 to 3,79 in mixed text and graphics mode */
void dloprint_bottom(char *str,int row,int col)
{
     char *crt;
     char c;
     int x, aux = 1, idx, jdx = 0;

     x = col / 2;
     if (col % 2) aux = 0;

     crt = (char *)(dlotextbase[row]+x);

     idx = 0;
     for (;;) {

	   c = str[idx]; idx++;
	   if (c == 0)break;
	   c+=128;
       if (aux == 1) {
	     dhraux[0] = 0; /* select auxiliary memory */
	     crt[jdx] = c;
	     aux = 0;
	   }
	   else {
		 dhrmain[0] = 0; /* reset to main memory */
		 crt[jdx] = c;
	     jdx++;
	     aux = 1;
	   }
   }

   /* safety play */
   dhrmain[0] = 0; /* reset to main memory */
}


/* 80 column mode must be set before calling */
#pragma optimize (push,off)
void dhireson(void)
{
	/* page 1 double hires */
    asm("sta $c050"); /* GRAPHICS				  */
    asm("sta $c052"); /* GRAPHICS ONLY, NOT MIXED */
    asm("sta $c054"); /* PAGE ONE				  */
    asm("sta $c057"); /* HI-RES					  */
    asm("sta $c05e"); /* TURN ON DOUBLE RES		  */
}
#pragma optimize (pop)

#pragma optimize (push,off)
void dhiresclear(unsigned char clearcolor)
{
	/* clear auxiliary screen memory */
    asm("sta $c055"); /* AUX MEM */
    memset((char *)0x2000,clearcolor,8192);

	/* clear main screen memory */
	asm("sta $c054"); /* MAIN MEM */
    memset((char *)0x2000,clearcolor,8192);

}
#pragma optimize (pop)

/* the following two routines work with all Apple IIe graphics modes */
#pragma optimize (push,off)
void mixedtexton(void)
{
	asm("sta $c053"); /* MIXED TEXT/GRAPHICS */
}
#pragma optimize (pop)

#pragma optimize (push,off)
void mixedtextoff(void)
{
	asm("sta  $c052"); /* GRAPHICS ONLY, NOT MIXED */
}
#pragma optimize (pop)

/* 80 column mode must be set to on after calling */
#pragma optimize (push,off)
void dhiresoff(void)
{
    asm("sta $c051"); /* TEXT - HIDE GRAPHICS */
    asm("sta $c05f"); /* TURN OFF DOUBLE RES  */
    asm("sta $c054"); /* PAGE ONE			  */
}
#pragma optimize (pop)

/* bilingual set-up functions */
int get_language()
{
	FILE *fp;
	int c, lang=-1;

   	fp = fopen("SILLYLANG","r");

   	if (fp != NULL) {
	  c = fgetc(fp);
	  if (c == EOF) c = 255;
	  c = toupper(c);
	  if (c == 'E' || c == 'A')lang = 0;
	  if (c == 'F') lang = 1;
	  fclose(fp);
	  fp = NULL;
	}

	if (lang == -1)lang = language;

    return lang;
}

int set_language()
{
    FILE *fp;
	int c, lang=-1;

    if (language == 1) c = 'F';
    else c = 'E';

	fp = fopen("SILLYLANG","r");
    if (fp != NULL) {
		fclose(fp);
		remove("SILLYLANG");
	}

   /* set file to sequential text */
    _filetype = 0x04;
    _auxtype = 0x0000;

   	fp = fopen("SILLYLANG","w");

   	if (fp != NULL) {
	  lang = language;
	  fputc(c,fp);
	  fputc(13,fp);
	  fclose(fp);
	  fp = NULL;
	}

    return lang;
}

void init_strings()
{
     int idx;

     for (idx = 0; idx < 10; idx++) {
		 if (language == FRENCH) sillies[idx] = fnames[idx];
		 else sillies[idx] = enames[idx];
	 }

     if (language == FRENCH) {
	    putdisk = fputdisk;
		saveprompt = fsaveprompt;
		savenot = fsavenot;
        wait = fwait;
        openerr = fopenerr;
        writerr = fwriterr;
        saveok = fsaveok;
        putprog = fputprog;
        anykey = fanykey;
        menu1 = fmenu1;
        menu2 = fmenu2;
	 }
	 else {
	    putdisk = eputdisk;
		saveprompt = esaveprompt;
		savenot = esavenot;
        wait = ewait;
        openerr = eopenerr;
        writerr = ewriterr;
        saveok = esaveok;
        putprog = eputprog;
        anykey = eanykey;
        menu1 = emenu1;
        menu2 = emenu2;
	 }
}

int flip_language(int lang)
{
	int templang = -1, idx;

	if ((lang == 'E' || lang == 'A') && language != ENGLISH) templang = ENGLISH;
	if (lang == 'F' && language != FRENCH) templang = FRENCH;

	if (templang !=  -1) {
		language = templang;
		init_strings();
		set_language();
		dloprint_bottom(menu1,0,0);
		dloprint_bottom(menu2,1,0);
	    for (idx = 0; idx < 40; idx++)sillyname[idx] = 32;
	    sillyname[40] = 0;
	    dloprint_bottom(sillyname,3,0);
        strcpy(sillyname,(char *)&sillies[todx][0]);
        strcat(sillyname,".");
        strcat(sillyname,(char *)&sillies[modx][0]);
        strcat(sillyname,".");
        strcat(sillyname,(char *)&sillies[bodx][0]);
 	    dloprint_bottom(sillyname,3,0);
	}
	return templang;
}

int dfraglode(char *name,int xoff,int y1)
{
	FILE *fp;
	int c,y,status=-1,width,height,packet;
	unsigned dest;

	fp = fopen(name,"rb");
	if (fp == NULL) return status;

	for (;;) {
		/* read 5 byte header */
		c = fread(lodebuf,1,5,fp);
		if (c != 5) break;
		if (lodebuf[0] != 'D' || lodebuf[1] != 'H' || lodebuf[2] != 'R') break;
		width = (int)lodebuf[3];
		height = (int)lodebuf[4];
		/* must be in a valid range */
		if (width < 4 || width > 80) break;
		if (height< 1 || height > 192) break;

		/* set status to 0 - SUCCESS */
		status = 0;

    	packet = width / 2;
    	xoff = xoff / 2;

		for (y = 0; y < height;y++,y1++) {
			c = fread(lodebuf,1,width,fp);
			if (c!= width) {
				status = -2;
				break;
			}
			dest = HB[y1] + xoff;

            /* move to auxiliary screen memory */
            dhraux[0] = 0; /* select auxiliary memory */
	        memcpy((char *)dest,(char *)&lodebuf[0],packet);

			/* move to main screen memory */
			dhrmain[0] = 0; /* reset to main memory */
			memcpy((char *)dest,(char *)&lodebuf[packet],packet);
		}
		break;
	}

   fclose(fp);
   return status;
}

/* display the image fragment */
int show_silly(int sidx)
{
	int c,idx, y;
	char fname[20];

	if (tidx > 9)tidx = 0;
	if (midx > 9)midx = 0;
	if (bidx > 9)bidx = 0;

	switch(sidx)
	{
		case 0:
		        y = 0;
				strcpy(fname,(char *)&enames[tidx][0]);
		        strcat(fname,"1.DHR");
		        todx = tidx;
		        tidx++;
		        break;
		case 1:
                y = 62;
		        strcpy(fname,(char *)&enames[midx][0]);
		        strcat(fname,"2.DHR");
		        modx = midx;
		        midx++;
		        break;
		case 2:
		        y = 132;
		        strcpy(fname,(char *)&enames[bidx][0]);
		        strcat(fname,"3.DHR");
		        bodx = bidx;
		        bidx++;
		        break;

		default: return -3;

	}

	c = dfraglode(fname,12,y);
	if(c== 0) {
        /* the new name will display if in mixed screen mode
           otherwise they can press the spacebar to toggle
           between fullscreen and mixed screen and they will
           see it then */

	    for (idx = 0; idx < 40; idx++)sillyname[idx] = 32;
	    sillyname[40] = 0;
	    dloprint_bottom(sillyname,3,0);
        strcpy(sillyname,(char *)&sillies[todx][0]);
        strcpy(proname,(char *)&enames[todx][0]);
        proname[5]=0;
        strcat(sillyname,".");
        strcat(sillyname,(char *)&sillies[modx][0]);
        strcat(proname,(char *)&enames[modx][0]);
        proname[10]=0;
        strcat(sillyname,".");
        strcat(sillyname,(char *)&sillies[bodx][0]);
        strcat(proname,(char *)&enames[bodx][0]);
        proname[15]=0;
	    dloprint_bottom(sillyname,3,0);
	}

	return c;
}

int a2fc_save(char *name)
{
	FILE *fp;
	int c, idx, status=0;
	unsigned src;

	/* remove file if it already exists */
	fp = fopen(name,"rb");
	if (fp != NULL) {
	   fclose(fp);
	   remove(name);
	}

	/* set filetype to binary */
	_filetype = 0x06;
	/* set auxiliary type to DHGR screen address */
	_auxtype = 0x2000;
	fp = fopen(name,"wb");
	if (fp == NULL)return -1;


	/* write 8192 bytes of auxiliary memory */
	src = 0x2000; /* set source to DHGR screen address */
	for (idx = 0;idx < 8; idx++) {
	   /* read auxiliary memory to main memory */
	   dhraux[0] = 0; /* select auxiliary memory */
	   memcpy((char *)&lodebuf[0],(char *)src,1024);
	   dhrmain[0] = 0; /* reset to main memory */
	   c = fwrite(lodebuf,1,1024,fp);
	   if (c != 1024) {
		 status = -2; break;
	   }
	   src += 1024;
	}

	if (status == 0) {
	   /* write 8192 bytes of main memory */
	   src = 0x2000; /* set source to DHGR screen address */
	   for (idx = 0;idx < 8; idx++) {
		   memcpy((char *)&lodebuf[0],(char *)src,1024);
		   c = fwrite(lodebuf,1,1024,fp);
		   if (c != 1024) {
			 status = -2; break;
		   }
		   src += 1024;
	   }
	}

	fclose(fp);

	if (status != 0) remove(name);

	return status;
}

/* save as an Apple II A2FC */
int save_silly()
{
	int c, oldbot = bottom;

	dloclear_bottom();
	if (oldbot != 1)mixedtexton();
	bottom = 1;
	dloprint_bottom(putdisk,0,0);
	dloprint_bottom(saveprompt,1,0);
	dloprint_bottom(savenot,2,0);
	dloprint_bottom(sillyname,3,0);

    c = cgetc();
    if (c == 13 || c == 32) {
		dloclear_bottom();
		dloprint_bottom(wait,0,0);
		dloprint_bottom(sillyname,3,0);
		c = a2fc_save(proname);
		switch(c) {
			case -1: dloprint_bottom(openerr,0,0); break;
			case -2: dloprint_bottom(writerr,0,0);break;
			default: dloprint_bottom(saveok,0,0);

		}
		dloprint_bottom(putprog,1,0);
		dloprint_bottom(anykey,2,0);
		cgetc();

	}
	else c = 0;

    if (oldbot != 1)mixedtextoff();
    bottom = oldbot;
    dloclear_bottom();
    dloprint_bottom(menu1,0,0);
	dloprint_bottom(menu2,1,0);
	dloprint_bottom(sillyname,3,0);

	return c;

}

